"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "BODIED_EXT_PADDING", {
  enumerable: true,
  get: function get() {
    return _styles.BODIED_EXT_PADDING;
  }
});
exports.overlay = void 0;
Object.defineProperty(exports, "padding", {
  enumerable: true,
  get: function get() {
    return _styles.EXTENSION_PADDING;
  }
});
exports.wrapperDefault = exports.styledImage = exports.placeholderFallbackParams = exports.placeholderFallback = void 0;
var _react = require("@emotion/react");
var _colors = require("@atlaskit/theme/colors");
var _styles = require("../../styles");
/* eslint-disable @atlaskit/design-system/no-exported-css */

var wrapperDefault = exports.wrapperDefault = (0, _react.css)({
  background: "var(--ds-background-neutral, ".concat(_colors.N20, ")"),
  borderRadius: "var(--ds-border-radius, 3px)",
  position: 'relative',
  verticalAlign: 'middle',
  '&.with-overlay': {
    '.extension-overlay': {
      background: "var(--ds-background-neutral-hovered, ".concat(_colors.N20A, ")"),
      color: 'transparent'
    },
    '&:hover .extension-overlay': {
      opacity: 1
    }
  }
});
var overlay = exports.overlay = (0, _react.css)({
  borderRadius: "var(--ds-border-radius, 3px)",
  position: 'absolute',
  width: '100%',
  height: '100%',
  opacity: 0,
  pointerEvents: 'none',
  transition: 'opacity 0.3s'
});
var placeholderFallback = exports.placeholderFallback = (0, _react.css)({
  display: 'inline-flex',
  alignItems: 'center',
  '& > img': {
    margin: "0 ".concat("var(--ds-space-050, 4px)")
  },
  /* TODO: fix in develop: https://atlassian.slack.com/archives/CFG3PSQ9E/p1647395052443259?thread_ts=1647394572.556029&cid=CFG3PSQ9E */
  /* stylelint-disable-next-line */
  label: 'placeholder-fallback'
});
var placeholderFallbackParams = exports.placeholderFallbackParams = (0, _react.css)({
  display: 'inline-block',
  maxWidth: '200px',
  marginLeft: "var(--ds-space-050, 4px)",
  color: "var(--ds-text-subtlest, ".concat(_colors.N70, ")"),
  textOverflow: 'ellipsis',
  whiteSpace: 'nowrap',
  overflow: 'hidden'
});
var styledImage = exports.styledImage = (0, _react.css)({
  maxHeight: '16px',
  maxWidth: '16px',
  /* TODO: fix in develop: https://atlassian.slack.com/archives/CFG3PSQ9E/p1647395052443259?thread_ts=1647394572.556029&cid=CFG3PSQ9E */
  /* stylelint-disable-next-line */
  label: 'lozenge-image'
});