"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _providerHelpers = require("../provider-helpers");
/**
 * Allow to run methods from the `ExtensionProvider` interface across all providers seamlessly.
 * This handles promise racing and discards rejected promises safely.
 */
var _default = exports.default = function _default(extensionProviders) {
  var _combineProviders = (0, _providerHelpers.combineProviders)(extensionProviders),
    invokeSingle = _combineProviders.invokeSingle,
    invokeList = _combineProviders.invokeList;
  return {
    getExtensions: function getExtensions() {
      return invokeList('getExtensions');
    },
    getExtension: function getExtension(type, key) {
      return invokeSingle('getExtension', [type, key]);
    },
    search: function search(keyword) {
      return invokeList('search', [keyword]);
    },
    getAutoConverter: function getAutoConverter() {
      return invokeList('getAutoConverter');
    }
  };
};