import { DOMSerializer } from '@atlaskit/editor-prosemirror/model';
import { findParentNodeOfType, findSelectedNodeOfType } from '@atlaskit/editor-prosemirror/utils';
export function getSelectedNodeOrNodeParentByNodeType({
  nodeType,
  selection
}) {
  let node = findSelectedNodeOfType(nodeType)(selection);
  if (!node) {
    node = findParentNodeOfType(nodeType)(selection);
  }
  return node;
}
export const toDOM = (node, schema) => {
  return DOMSerializer.fromSchema(schema).serializeNode(node);
};