/// <reference types="react" />
import type { UIAnalyticsEvent } from '@atlaskit/analytics-next';
import type { EditorView } from '@atlaskit/editor-prosemirror/view';
import type { HyperlinkState } from '../../../link';
import type { ProviderFactory } from '../../../provider-factory';
import type { Command, LinkInputType, LinkPickerOptions } from '../../../types';
import type { EditorLinkPickerProps } from '../EditorLinkPicker';
export interface HyperlinkAddToolbarProps extends Pick<EditorLinkPickerProps, 'onCancel' | 'invokeMethod' | 'onClose'> {
    view: EditorView;
    providerFactory: ProviderFactory;
    onSubmit: (href: string, title: string | undefined, displayText: string | undefined, inputMethod: LinkInputType, analytic?: UIAnalyticsEvent | null | undefined) => void;
    lpLinkPicker: boolean;
    linkPickerOptions?: LinkPickerOptions;
    displayText?: string;
    displayUrl?: string;
    onEscapeCallback?: Command;
    onClickAwayCallback?: Command;
}
export declare function HyperlinkAddToolbar({ linkPickerOptions, onSubmit, displayText, displayUrl, providerFactory, view, onCancel, invokeMethod, lpLinkPicker, onClose, onEscapeCallback, onClickAwayCallback, hyperlinkPluginState, }: HyperlinkAddToolbarProps & {
    hyperlinkPluginState: HyperlinkState | undefined;
}): JSX.Element;
