/** @jsx jsx */
import React from 'react';
import type { WithAnalyticsEventsProps } from '@atlaskit/analytics-next';
import type { PaletteColor, PaletteTooltipMessages } from '../../ui-color';
import type { Position as PopupPosition } from '../../ui/Popup/utils';
type Props = WithAnalyticsEventsProps & {
    currentColor?: string;
    title?: string;
    isAriaExpanded?: boolean;
    onChange?: (color: PaletteColor) => void;
    colorPalette: PaletteColor[];
    placement: string;
    cols?: number;
    alignX?: 'left' | 'right' | 'center' | 'end';
    size?: {
        width: string;
        height: string;
    };
    mountPoint?: HTMLElement;
    setDisableParentScroll?: (disable: boolean) => void;
    hexToPaletteColor?: (hexColor: string) => string | undefined;
    paletteColorTooltipMessages?: PaletteTooltipMessages;
    /**
     * After picking the color the default behaviour is to focus the color picker button.
     * To prevent this use skipFocusButtonAfterPick.
     */
    skipFocusButtonAfterPick?: boolean;
    absoluteOffset?: PopupPosition;
};
declare const _default: React.ForwardRefExoticComponent<Pick<Omit<Props, keyof WithAnalyticsEventsProps> & React.RefAttributes<any> & import("@atlaskit/analytics-next").WithContextProps, "size" | "currentColor" | "onChange" | "title" | "key" | "placement" | "alignX" | "absoluteOffset" | "analyticsContext" | "cols" | "isAriaExpanded" | "hexToPaletteColor" | "paletteColorTooltipMessages" | "colorPalette" | "mountPoint" | "setDisableParentScroll" | "skipFocusButtonAfterPick"> & React.RefAttributes<any>>;
export default _default;
