import { PureComponent } from 'react';
import type { EmojiResourceConfig } from '@atlaskit/emoji/resource';
import type { EmojiId } from '@atlaskit/emoji/types';
import { ProviderFactory } from '../../provider-factory';
export interface EmojiProps extends EmojiId {
    allowTextFallback?: boolean;
    providers?: ProviderFactory;
    fitToHeight?: number;
    showTooltip?: boolean;
    resourceConfig?: EmojiResourceConfig;
}
export default class EmojiNode extends PureComponent<EmojiProps, {}> {
    static displayName: string;
    static defaultProps: {
        showTooltip: boolean;
    };
    private providerFactory;
    constructor(props: EmojiProps);
    componentWillUnmount(): void;
    private renderWithProvider;
    render(): JSX.Element;
}
