import type { Node as PMNode, Schema } from '@atlaskit/editor-prosemirror/model';
import { ACTION_SUBJECT_ID } from '../analytics';
import type { UnsupportedContentPayload, UnsupportedContentTooltipPayload } from './analytics';
type DispatchAnalyticsEvent = (payload: UnsupportedContentPayload) => void;
type DispatchAnalyticsEventTooltip = (payload: UnsupportedContentTooltipPayload) => void;
export declare const findAndTrackUnsupportedContentNodes: (node: PMNode, schema: Schema, dispatchAnalyticsEvent: DispatchAnalyticsEvent, ancestorHierarchy?: string) => void;
interface UnsupportedNode {
    type: string;
    ancestry: string;
    parentType: string;
    marks: {
        [key: string]: any;
    }[];
    attrs: {
        [key: string]: any;
    };
}
export declare const fireUnsupportedEvent: (dispatchAnalyticsEvent: DispatchAnalyticsEvent, actionSubjectId: ACTION_SUBJECT_ID, unsupportedNode: UnsupportedNode, errorCode?: string) => void;
export declare const trackUnsupportedContentTooltipDisplayedFor: (dispatchAnalyticsEvent: DispatchAnalyticsEventTooltip, unsupportedContentType: UnsupportedContentTooltipPayload['actionSubjectId'], originalNodeType?: string) => void;
export {};
