/** @jsx jsx */
import React from 'react';
import type { WithAnalyticsEventsProps } from '@atlaskit/analytics-next';
import type { QuickInsertItem } from '../../provider-factory';
import type { EmptyStateHandler } from '../../types';
import type { Category, Modes } from '../types';
export type StatelessElementBrowserProps = {
    categories?: Category[];
    items: QuickInsertItem[];
    onSearch: (searchTerm: string) => void;
    onSelectCategory: (category: Category) => void;
    onSelectItem?: (item: QuickInsertItem) => void;
    onInsertItem: (item: QuickInsertItem) => void;
    selectedCategory?: string;
    showSearch: boolean;
    showCategories: boolean;
    mode: keyof typeof Modes;
    searchTerm?: string;
    emptyStateHandler?: EmptyStateHandler;
    viewMoreItem?: QuickInsertItem;
} & WithAnalyticsEventsProps;
declare const MemoizedElementBrowser: React.MemoExoticComponent<React.ForwardRefExoticComponent<Pick<Omit<StatelessElementBrowserProps, keyof WithAnalyticsEventsProps> & React.RefAttributes<any> & import("@atlaskit/analytics-next").WithContextProps, "key" | "mode" | "analyticsContext" | "categories" | "onSelectCategory" | "selectedCategory" | "items" | "emptyStateHandler" | "searchTerm" | "onInsertItem" | "onSearch" | "onSelectItem" | "viewMoreItem" | "showCategories" | "showSearch"> & React.RefAttributes<any>>>;
export default MemoizedElementBrowser;
