import React, { ComponentType } from 'react';
export interface ImageLoaderProps {
    url?: string;
    onExternalImageLoaded?: (dimensions: {
        width: number;
        height: number;
    }) => void;
    imageStatus?: ImageStatus;
}
export interface ImageLoaderState {
    imageStatus: ImageStatus;
}
export type ImageStatus = 'complete' | 'loading' | 'error';
export declare const withImageLoader: <P extends {}>(Wrapped: ComponentType<React.PropsWithChildren<P & ImageLoaderProps>>) => React.ComponentClass<P & ImageLoaderProps>;
